/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.ac.leeds.ccg.jianhuij.nn;

import com.tictactec.ta.lib.Core;
import com.tictactec.ta.lib.MInteger;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.StringTokenizer;
import java.util.Vector;
import uk.ac.leeds.ccg.jianhuij.table.Table;
import uk.ac.leeds.ccg.jianhuij.table.TableFactory;

/**
 *
 * @author Administrator
 */
public class ANNInputOutput {

    static long SHIndexTradeVolumeBase = 400000000;
    static long SHIndexTradeValueBase = 40000000;
    static int SHIndexBase = 7000;
    static int NumberOfDayForTrainingInput = 100;
    static int NumberOfDayForTrainingOutput = 10;
    static int LagOrPredictionDays = 5;
    static Core TA_Core = new Core();

    public static double[][] readMultilDataFile(String fileDir) {

        File[] trainInputFiles = new File(fileDir).listFiles();
        double[][] trainInput = null;
        try {
            // intialise the input array
            BufferedReader br = new BufferedReader(new FileReader(trainInputFiles[0]));
            int trainDataLength = 0;
            while (br.readLine() != null) {
                trainDataLength++;
            }
            br.close();

            trainInput = new double[trainDataLength][trainInputFiles.length];
            for (int i = 0; i < trainInputFiles.length; i++) {
                br = new BufferedReader(new FileReader(trainInputFiles[i]));
                String stringTemp = null;
                int j = 0;
                while ((stringTemp = br.readLine()) != null) {
                    trainInput[j][i] = Double.parseDouble(stringTemp);
                    // System.out.println(trainInput[i][j]+"");
                    j++;
                }
                br.close();
            }
        } catch (Exception e) {
            e.printStackTrace();

        }

        return trainInput;
    }

    public static double[][] readSingleDataFile(String fileDir) {

        File trainInputFile = new File(fileDir);
        double[][] trainInput = null;
        try {
            // intialise the input array
            BufferedReader br = new BufferedReader(new FileReader(trainInputFile));

            int trainDataNumber = 0;
            // skip head
            br.readLine();

            int trainDataLength = 1;
            String lineTemp = br.readLine();
            StringTokenizer st = new StringTokenizer(lineTemp, ",");
            for (int i = 0; st.hasMoreTokens(); i++) {
                trainDataNumber++;
            }

            while (br.readLine() != null) {
                trainDataLength++;
            }
            br.close();


            br = new BufferedReader(new FileReader(trainInputFile));
            //skip the head
            br.readLine();
            trainInput = new double[trainDataLength][trainDataNumber];
            for (int i = 0; i < trainDataNumber; i++) {

                while ((lineTemp = br.readLine()) != null) {
                    st = new StringTokenizer(lineTemp, ",");
                    for (int j = 0; st.hasMoreTokens(); j++) {
                        trainInput[j][i] = Double.parseDouble(st.nextToken());
                        System.out.print(trainInput[j][i] + "");
                    }
                    System.out.println();



                }
            }
            br.close();
        } catch (Exception e) {
            e.printStackTrace();

        }

        return trainInput;
    }

    /**
     * 
     * 
     * @param fileDir
     * @return double[0][][] is train input double[1][][] for train output
     */
    public static double[][][] readSimpleTrainingDataTable(String fileDir) {
        double[][] trainX = null;
        double[][] trainY = null;
        try {
            Table dataTable = TableFactory.createTable(fileDir);
            int nrow = dataTable.getRowCount();
            int ncol = dataTable.getColumnCount();
            Vector patternX = new Vector();
            Vector patternY = new Vector();

            for (int i = nrow - 1; i > LagOrPredictionDays; i--) {
                if (((Number) (dataTable.getFullValueAt(i, 0))).intValue() < 19950000) {
                    continue;
                } else {
                    double[] x = new double[12];

                    x[0] = ((Number) dataTable.getFullValueAt(i, 1)).doubleValue() / SHIndexBase;
                    x[1] = ((Number) dataTable.getFullValueAt(i, 2)).doubleValue() / SHIndexBase;
                    x[2] = ((Number) dataTable.getFullValueAt(i, 3)).doubleValue() / SHIndexBase;
                    x[3] = ((Number) dataTable.getFullValueAt(i, 4)).doubleValue() / SHIndexBase;
                    // total trade values
                    x[4] = ((Number) dataTable.getFullValueAt(i, 5)).doubleValue() / 50000000.0d;
                    // total trade volume
                    x[5] = ((Number) dataTable.getFullValueAt(i, 6)).doubleValue() / 500000000.0d;

                    x[6] = ((Number) dataTable.getFullValueAt(i, 7)).doubleValue() / SHIndexBase;
                    x[7] = ((Number) dataTable.getFullValueAt(i, 8)).doubleValue() / SHIndexBase;
                    x[8] = ((Number) dataTable.getFullValueAt(i, 9)).doubleValue() / SHIndexBase;
                    x[9] = ((Number) dataTable.getFullValueAt(i, 10)).doubleValue() / SHIndexBase;
                    x[10] = ((Number) dataTable.getFullValueAt(i, 11)).doubleValue() / SHIndexBase;
                    x[11] = ((Number) dataTable.getFullValueAt(i, 12)).doubleValue() / SHIndexBase;

                    double[] y = new double[LagOrPredictionDays];
                    // the next day y
                    for (int j = 0; j < y.length; j++) {
                        y[j] = ((Number) (dataTable.getFullValueAt(i - j, 4))).doubleValue() / SHIndexBase;
                    }
                    patternX.add(x);
                    patternY.add(y);
                }
            }

            trainX = new double[patternX.size()][];
            trainY = new double[patternY.size()][];
            if (trainX.length != trainY.length) {
                throw new Exception("data length is not equal: X Length: " + trainX.length + " Y Length: " + trainY.length);
            }

            for (int i = 0; i < trainX.length; i++) {
                trainX[i] = (double[]) patternX.get(i);
                trainY[i] = (double[]) patternY.get(i);
            }

        } catch (Exception e) {
            e.printStackTrace();

        }

        return new double[][][]{trainX, trainY};
    }

    public static double[][] readSimplePredictionDataTable(String fileDir) {
        double[][] predictionX = null;
        try {
            Table dataTable = TableFactory.createTable(fileDir);
            int nrow = dataTable.getRowCount();
            int ncol = dataTable.getColumnCount();
            Vector patternX = new Vector();

            for (int i = LagOrPredictionDays - 1; i >=0; i--) {

                double[] x = new double[12];

                x[0] = ((Number) dataTable.getFullValueAt(i, 1)).doubleValue() / SHIndexBase;
                x[1] = ((Number) dataTable.getFullValueAt(i, 2)).doubleValue() / SHIndexBase;
                x[2] = ((Number) dataTable.getFullValueAt(i, 3)).doubleValue() / SHIndexBase;
                x[3] = ((Number) dataTable.getFullValueAt(i, 4)).doubleValue() / SHIndexBase;
                // total trade values
                x[4] = ((Number) dataTable.getFullValueAt(i, 5)).doubleValue() / 50000000.0d;
                // total trade volume
                x[5] = ((Number) dataTable.getFullValueAt(i, 6)).doubleValue() / 500000000.0d;

                x[6] = ((Number) dataTable.getFullValueAt(i, 7)).doubleValue() / SHIndexBase;
                x[7] = ((Number) dataTable.getFullValueAt(i, 8)).doubleValue() / SHIndexBase;
                x[8] = ((Number) dataTable.getFullValueAt(i, 9)).doubleValue() / SHIndexBase;
                x[9] = ((Number) dataTable.getFullValueAt(i, 10)).doubleValue() / SHIndexBase;
                x[10] = ((Number) dataTable.getFullValueAt(i, 11)).doubleValue() / SHIndexBase;
                x[11] = ((Number) dataTable.getFullValueAt(i, 12)).doubleValue() / SHIndexBase;

                patternX.add(x);
            }

            predictionX = new double[patternX.size()][];
            for (int i = 0; i < predictionX.length; i++) {
                predictionX[i] = (double[]) patternX.get(i);
            }

        } catch (Exception e) {
            e.printStackTrace();

        }

        return predictionX;
    }

    public static double[][][] readPilotTrainingDataTable(String fileDir) {
        double[][] trainX = null;
        double[][] trainY = null;
        try {
            Table dataTable = TableFactory.createTable(fileDir);
            int nrow = dataTable.getRowCount();
            int ncol = dataTable.getColumnCount();
            Vector patternX = new Vector();
            Vector patternY = new Vector();

            for (int i = nrow - 1; i > LagOrPredictionDays; i--) {
                if (((Number) (dataTable.getFullValueAt(i, 0))).intValue() < 20060000) {
                    continue;
                } else {
                    double[] x = new double[8];

//                    x[0] = ((Number) dataTable.getFullValueAt(i, 2)).doubleValue() / SHIndexBase;
//
//                    x[1] = ((Number) dataTable.getFullValueAt(i, 3)).doubleValue() / SHIndexBase;

                    // -5 days total trade volume
                    x[0] = ((Number) dataTable.getFullValueAt(i + 5, 6)).doubleValue() / 500000000.0d;

                    // closing price
                    x[1] = ((Number) dataTable.getFullValueAt(i, 4)).doubleValue() / SHIndexBase;

                    // total trade volume
                    x[2] = ((Number) dataTable.getFullValueAt(i, 6)).doubleValue() / 500000000.0d;
                    // MA 5,10,20,....
//                    x[4] = ((Number) dataTable.getFullValueAt(i, 7)).doubleValue() / SHIndexBase;
//                    x[5] = ((Number) dataTable.getFullValueAt(i, 8)).doubleValue() / SHIndexBase;
//                    x[6] = ((Number) dataTable.getFullValueAt(i, 9)).doubleValue() / SHIndexBase;
//                    x[7] = ((Number) dataTable.getFullValueAt(i, 10)).doubleValue() / SHIndexBase;
//                    x[8] = ((Number) dataTable.getFullValueAt(i, 11)).doubleValue() / SHIndexBase;
//                    x[9] = ((Number) dataTable.getFullValueAt(i, 12)).doubleValue() / SHIndexBase;

                    // MACD
                    x[3] = ((Number) dataTable.getFullValueAt(i, 15)).doubleValue() / 400.0d + 0.5;
                    // adx
                    x[4] = ((Number) dataTable.getFullValueAt(i, 18)).doubleValue() / 100.0d;

                    // -5 days close price
                    x[5] = ((Number) dataTable.getFullValueAt(i + 5, 4)).doubleValue() / SHIndexBase;
                    // k
                    x[6] = ((Number) dataTable.getFullValueAt(i, 20)).doubleValue() / 100.0d;
                    // d
                    x[7] = ((Number) dataTable.getFullValueAt(i, 21)).doubleValue() / 100.0d;

//                    x[9] = getMACD(dataTable, i) / 400.0d + 0.5;
//                    x[10] = getADX(dataTable, i) / 100.0d;
                    double[] y = new double[1];
                    // the next day y
                    y[0] = ((Number) (dataTable.getFullValueAt(i - LagOrPredictionDays, 4))).doubleValue() / SHIndexBase;


//                    double[] y = new double[LagOrPredictionDays];
//                    // the next day y
//                    for (int j = 0; j < y.length; j++) {
//                        y[j] = ((Number) (dataTable.getFullValueAt(i - j, 4))).doubleValue() / SHIndexBase;
//                    }
                    patternX.add(x);
                    patternY.add(y);
                }
            }

            trainX = new double[patternX.size()][];
            trainY = new double[patternY.size()][];
            if (trainX.length != trainY.length) {
                throw new Exception("data length is not equal: X Length: " + trainX.length + " Y Length: " + trainY.length);
            }

            for (int i = 0; i < trainX.length; i++) {
                trainX[i] = (double[]) patternX.get(i);
                trainY[i] = (double[]) patternY.get(i);
            }

        } catch (Exception e) {
            e.printStackTrace();

        }

        return new double[][][]{trainX, trainY};
    }

    public static double[][] readPilotPredictionDataTable(String fileDir) {
        double[][] predictionX = null;
        try {
            Table dataTable = TableFactory.createTable(fileDir);
            int nrow = dataTable.getRowCount();
            int ncol = dataTable.getColumnCount();
            Vector patternX = new Vector();

            for (int i = LagOrPredictionDays - 1; i >=0; i--) {

                double[] x = new double[8];

//                    x[0] = ((Number) dataTable.getFullValueAt(i, 2)).doubleValue() / SHIndexBase;
//
//                    x[1] = ((Number) dataTable.getFullValueAt(i, 3)).doubleValue() / SHIndexBase;

                // -5 days total trade volume
                x[0] = ((Number) dataTable.getFullValueAt(i + 5, 6)).doubleValue() / 500000000.0d;

                // closing price
                x[1] = ((Number) dataTable.getFullValueAt(i, 4)).doubleValue() / SHIndexBase;

                // total trade volume
                x[2] = ((Number) dataTable.getFullValueAt(i, 6)).doubleValue() / 500000000.0d;
                // MA 5,10,20,....
//                    x[4] = ((Number) dataTable.getFullValueAt(i, 7)).doubleValue() / SHIndexBase;
//                    x[5] = ((Number) dataTable.getFullValueAt(i, 8)).doubleValue() / SHIndexBase;
//                    x[6] = ((Number) dataTable.getFullValueAt(i, 9)).doubleValue() / SHIndexBase;
//                    x[7] = ((Number) dataTable.getFullValueAt(i, 10)).doubleValue() / SHIndexBase;
//                    x[8] = ((Number) dataTable.getFullValueAt(i, 11)).doubleValue() / SHIndexBase;
//                    x[9] = ((Number) dataTable.getFullValueAt(i, 12)).doubleValue() / SHIndexBase;

                // MACD
                x[3] = ((Number) dataTable.getFullValueAt(i, 15)).doubleValue() / 400.0d + 0.5;
                // adx
                x[4] = ((Number) dataTable.getFullValueAt(i, 18)).doubleValue() / 100.0d;

                // -5 days close price
                x[5] = ((Number) dataTable.getFullValueAt(i + 5, 4)).doubleValue() / SHIndexBase;
                // k
                x[6] = ((Number) dataTable.getFullValueAt(i, 20)).doubleValue() / 100.0d;
                // d
                x[7] = ((Number) dataTable.getFullValueAt(i, 21)).doubleValue() / 100.0d;

//                    x[9] = getMACD(dataTable, i) / 400.0d + 0.5;
//                    x[10] = getADX(dataTable, i) / 100.0d;

                patternX.add(x);
            }

            predictionX = new double[patternX.size()][];
            for (int i = 0; i < predictionX.length; i++) {
                predictionX[i] = (double[]) patternX.get(i);
            }

        } catch (Exception e) {
            e.printStackTrace();

        }

        return predictionX;
    }

    private static double getADX(Table dataTable, int row) {
        double[] out = new double[1];
        int timePeriod = 18;
        int retrieveDays = TA_Core.adxLookback(timePeriod) + 1;
        double[] inHigh = new double[retrieveDays];
        double[] inLow = new double[retrieveDays];
        double[] inClose = new double[retrieveDays];

        for (int i = 0; i < retrieveDays; i++) {
            inHigh[retrieveDays - i - 1] = ((Number) dataTable.getFullValueAt(i + row, 2)).doubleValue();
            inLow[retrieveDays - i - 1] = ((Number) dataTable.getFullValueAt(i + row, 3)).doubleValue();
            inClose[retrieveDays - i - 1] = ((Number) dataTable.getFullValueAt(i + row, 4)).doubleValue();
        }
        MInteger outBegIdx = new MInteger();
        outBegIdx.value = retrieveDays - 1;
        MInteger outNbElement = new MInteger();
        outNbElement.value = 1;
        TA_Core.adx(0, retrieveDays - 1, inHigh, inLow, inClose, timePeriod, outBegIdx, outNbElement, out);
        System.out.println(out[0]);
        return out[0];
    }

    private static double getMACD(Table dataTable, int row) {
        double[] outMACD = new double[1];
        double[] outMACDSignal = new double[1];
        double[] outMACDHist = new double[1];
        int retrieveDays = TA_Core.macdLookback(15, 26, 9) + 1;
        double[] inReal = new double[retrieveDays];

        for (int i = 0; i < retrieveDays; i++) {
            inReal[retrieveDays - i - 1] = ((Number) dataTable.getFullValueAt(i + row, 4)).doubleValue();
        }
        MInteger outBegIdx = new MInteger();
        outBegIdx.value = retrieveDays - 1;
        MInteger outNbElement = new MInteger();
        outNbElement.value = 1;
        TA_Core.macd(0, retrieveDays - 1, inReal, 12, 26, 9,
                outBegIdx,
                outNbElement,
                outMACD,
                outMACDSignal,
                outMACDHist);

        System.out.println(outMACD[0]);
        return outMACD[0];
    }

    public static void main(String[] paras) {
        //readTrainingDataTable("C:/Users/Administrator/Documents/stock/research/AI/neural/testdata/testIn/szzs.csv");
        readPilotTrainingDataTable("C:/Users/Administrator/Documents/stock/research/AI/neural/testdata/testIn/szzs.csv");
    }
}
