/*
 * GeneticUtility.java
 *
 * Created on July 17, 2002, 5:37 PM
 */

package uk.ac.leeds.ccg.jianhuij.nn;

/**
 *
 * @author  ma0101
 */
public class NNUtility {
    
    /** Creates a new instance of GeneticUtility */
    public NNUtility() {
    }
    public static int getBite(int value,int position) {
        return (value&((int)Math.pow(2,position)))>>position;
    }
    public static int randomInt(int size){
        return new Double( Math.random() * size ).intValue();
    }
    
    public static double getRMS( double[] fire, double[] target ) {
        double temp=0.0;
        for(int i=0;i<fire.length;i++) {
            temp= temp + (fire[i]-target[i]) * (fire[i]-target[i]);
        }
        temp = Math.sqrt(temp / (fire.length-1));
        return temp;
        
    }
    
    public static double getRMS( double[][] fire, double[][] target ) {
        double RMSSum = 0.0;
               
        for ( int i = 0 ; i < fire[0].length ; i++ ){
            
            double errorSquareSum = 0.0; 
            int noDataCount = 0;
            
            for ( int j = 0 ; j < fire.length ; j ++ ) {
                
               if ( ( fire[j][i] == -9999.0 ) || ( target[j][i] == -9999.0 ) ) { noDataCount++; continue; }
                
                errorSquareSum = errorSquareSum + ( fire[j][i] - target[j][i] ) * ( fire[j][i] - target[j][i] );
                
            }
            
            RMSSum = RMSSum + Math.sqrt( errorSquareSum / ( fire.length - 1 - noDataCount ) );
            
        }
        
        RMSSum = RMSSum / fire[0].length ;
        return RMSSum;
    }
    
    public static double getRMS( double[][] fire, double[][] target, double noDataValue ) {
        double RMSSum = 0.0;
               
        for ( int i = 0 ; i < fire[0].length ; i++ ){
            
            double errorSquareSum = 0.0;
            int noDataCount = 0;
            
            for ( int j = 0 ; j < fire.length ; j ++ ) {
                
                if ( ( fire[j][i] == noDataValue ) || ( target[j][i] == noDataValue ) ) { noDataCount++; continue; }
                
                errorSquareSum = errorSquareSum + ( fire[j][i] - target[j][i] ) * ( fire[j][i] - target[j][i] );
                
            }
            
            RMSSum = RMSSum + Math.sqrt( errorSquareSum / ( fire.length - 1 - noDataCount ) );
            
        }
        
        return RMSSum / fire[0].length ;
        
    }
    
    public static double[] getSingleArray( double[][] multi, int index ) {
        double[] temp=new double[multi.length];
        for(int i=0;i<multi.length;i++){
            temp[i]=multi[i][index];
        }
        return temp;
    }
    
    public static double getRerangedValue( double value, double max, double min, double nodatavalue){
        if( value == nodatavalue ) { return value; }
        else{
            value = ( value - min ) / ( max - min );
            return value;
        }
    }
    
    
    
}
