package uk.ac.leeds.ccg.jianhuij.nn;

/*
 * OutNeuro.java
 *
 * Created on June 17, 2002, 5:40 PM
 */


/**
 *
 * @author  mikec
 * @version
 */
public class OutNeuron extends Object implements java.io.Serializable{
    
    double rate = 0.25; // learning rate;
    int inputNumber =0;
    double alfa=1.0;
    double[] weight = null;
    double[] oldWeight = null;
    
    double dot=0;
    double fire=0;
    
    double[] input=null;
    
    double errorSignal=0;
    
    double[] lastTimeWeightChange=null;
    private void ini(int inputNumber, double rate, double alfa){
        this.inputNumber=inputNumber;
        this.rate=rate;
        this.alfa=alfa;
        this.weight=new double[inputNumber + 1];
        this.oldWeight=new double[inputNumber + 1];
        this.lastTimeWeightChange=new double[inputNumber + 1];
        for(int i=0;i<inputNumber+1;i++)
        {
            weight[i] = Math.random();
        }
        
    }
    
    /** Creates new OutNeuro */
    public OutNeuron(int inputNumber, double rate,double alfa) {
        
        ini(inputNumber, rate, alfa);
        
    }
    
    
    // feed data into the model
    public void process(double[] input)
    {
        
       
        this.input=input;
        
        dot=weight[0];
        
        for(int i =0;i<inputNumber;i++)
        {
            dot = dot + weight[i+1]*input[i];
        }
        
        
        fire =  1/(1 + Math.exp(-1*alfa*dot));
        
        
    }
    
    
    public void WAdjust(double y){
        errorSignal= alfa*(y-fire)*(1-fire)*fire;
        
        oldWeight[0]=weight[0];
        weight[0]=weight[0] + errorSignal*rate+lastTimeWeightChange[0]*0.9;
        lastTimeWeightChange[0]= weight[0]-oldWeight[0];
        for(int i=0;i<inputNumber;i++)
        {
            oldWeight[i+1]=weight[i+1];
            weight[i+1]=weight[i+1] + errorSignal*input[i]*rate+lastTimeWeightChange[i+1]*0.9;
            lastTimeWeightChange[0]= weight[i+1]-oldWeight[i+1];
        }
        
    }
    
    
  /*  public void train(double[] input, double y){
        process(input);
        WAdjust(y);
    }
    */
    public double getFire(){
        return fire;
        
    }
    
    public double[][] getOldWeight(){
        double[][] temp=new double[inputNumber][1];
        
        for(int i=0;i<inputNumber;i++)
            temp[i][0]=oldWeight[i+1];
        
        return temp;
    }
    
    public double[] getErrorSignal(){
        double[] temp = new double[1];
        
        temp[0]=errorSignal;
        return temp;
    }
    
    public double[] getWeight() {
        return this.weight;
    }
    public void setWeight(double[] weight){
      for(int i=0;i<weight.length;i++)
        this.weight[i]=weight[i];
    }
    
}
