/*
 * Test.java
 *
 * Created on August 8, 2002, 1:11 AM
 */
package uk.ac.leeds.ccg.jianhuij.nn;

import java.util.Vector;

/**
 *
 * @author  Jianhui Jin
 */
public class Test {

    /** Creates a new instance of TestOut */
    public Test() {
    }

    public static void testBackProbagation() {
        String dataTable = "C:/Users/Jianhui Jin/Work/OS/Development/testdata/testIn/szzs.csv";
        double[][][] xAndY = ANNInputOutput.readPilotTrainingDataTable(dataTable);
        for (int restart = 0; restart < 1; restart++) {
            NeuroNetwork nn = new NeuroNetwork(new int[]{20},
                    xAndY[0][0].length,
                    0.25, 1,
                    xAndY[1][0].length);
            double lastRMSE = Double.MAX_VALUE;
            double currentRMSE = Double.MAX_VALUE;
            double[][] fire = null;
            do {
                lastRMSE = currentRMSE;
                try {
                    fire = nn.trainNN(xAndY[0], xAndY[1]);
                } catch (Exception e) {
                    e.printStackTrace();
                }
                currentRMSE = nn.getRMSE();
                System.out.println(nn.getRMSE());

            } while ((lastRMSE - currentRMSE) > 0);

            for (int i = 0; i < fire.length; i++) {
                System.out.println(xAndY[1][i][0] + " fire: " + fire[i][0]);
            }

            double[][] prediction = nn.runNN(ANNInputOutput.readPilotPredictionDataTable(dataTable));
            for (int i = 0; i < prediction.length; i++) {
                System.out.println();
                for (int j = 0; j < prediction[i].length; j++) {
                    System.out.println(prediction[i][j] * 7000);
                }
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void testSimulatedAnnealing() {
        String dataTable = "C:/Users/Jianhui Jin/Documents/stock/research/AI/neural/testdata/testIn/szzs.csv";
        double[][][] xAndY = ANNInputOutput.readPilotTrainingDataTable(dataTable);
        Vector predictVector = new Vector();
        for (int restart = 0; restart < 100; restart++) {
            System.out.println("Restart " + restart);
            NeuroNetwork nn = new NeuroNetwork(new int[]{10},
                    xAndY[0][0].length,
                    0.25, 1,
                    xAndY[1][0].length);
            SimulatedAnnealing sa = new SimulatedAnnealing(500, 0.01, 0.05, 5000, 1, nn, xAndY[0], xAndY[1]);
            sa.run();

            double[][] prediction = nn.runNN(ANNInputOutput.readPilotPredictionDataTable(dataTable));
            predictVector.add(prediction);
        }

        double[][] averagedPrediction = (double[][]) predictVector.get(0);
        for (int i = 1; i < predictVector.size(); i++) {
            for (int j = 0; j < ((double[][]) predictVector.get(i)).length; j++) {
                for (int m = 0; m < ((double[][]) predictVector.get(i))[j].length; m++) {
                    averagedPrediction[j][m] = averagedPrediction[j][m] + ((double[][]) predictVector.get(i))[j][m];
                }
            }
        }

        for (int i = 0; i < averagedPrediction.length; i++) {
            System.out.println();
            
            for (int j = 0; j < averagedPrediction[i].length; j++) {
                System.out.println(averagedPrediction[i][j] * 7000 / predictVector.size() );
            }
        }

    }

    public static void main(String[] args) {
        testSimulatedAnnealing();
       // testBackProbagation();
    }
}
