/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.ac.leeds.ccg.jianhuij.os;

import java.io.File;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Vector;
import uk.ac.leeds.ccg.andyt.grids.core.AbstractGrid2DSquareCell;
import uk.ac.leeds.ccg.andyt.grids.core.Grid2DSquareCellDoubleFactory;

/**
 *
 * @author Jianhui Jin
 */
public class OSTrainingInputOutput {

    public static double[][][] readTrainingInputOutput() {
        String folder = "C:/Users/Jianhui Jin/Work/OS/Development/TestData/TestTrainningInput/";
        File[] allFiles = new File(folder).listFiles();
        Hashtable<File, Double> fileName2RoofTypeValue = new Hashtable<File, Double>();
        double[][] trainXArray = null;
        double[][] trainYArray = null;
        Vector<double[]> trainX = new Vector<double[]>();
        Vector<double[]> trainY = new Vector<double[]>();
        double minElevation = Double.POSITIVE_INFINITY;
        double maxElevation = Double.NEGATIVE_INFINITY;

        for (int i = 0; i < allFiles.length; i++) {
            if (allFiles[i].isFile() && (allFiles[i].getName().toUpperCase().endsWith(".ASC"))) {
                Grid2DSquareCellDoubleFactory gdf = new Grid2DSquareCellDoubleFactory(new File(folder), -9999.0, new HashSet(), false);
                AbstractGrid2DSquareCell g1 = gdf.create(allFiles[i]);
                long ncol = g1.get_NCols(true);
                long nrow = g1.get_NRows(true);
                // collect all data and the min and max
                for (int m = 0; m < nrow; m++) {
                    for (int n = 0; n < ncol; n++) {

                        if (g1.getCellDouble(m, n, false) < minElevation) {
                            minElevation = g1.getCellDouble(m, n, false);
                        }
                        if (g1.getCellDouble(m, n, false) > maxElevation) {
                            maxElevation = g1.getCellDouble(m, n, false);
                        }
                    }
                }


//                for (int j = 0; j < allFiles.length; j++) {
//                    if (allFiles[j].isDirectory() && (allFiles[j].getName().toLowerCase().contains(allFiles[i].getName().toLowerCase().replaceAll(".asc", "")))) {
//                        g1 = gdf.create(allFiles[i]);
//                        ncol = g1.get_NCols(true);
//                        nrow = g1.get_NRows(true);
//                        for (int m = 0; m < nrow; m++) {
//                            for (int n = 0; n < ncol; n++) {
//                                x[(int) ncol * (int) nrow - 1 + m * (int) ncol + n] = g1.getCellDouble(m, n, true);
//                            }
//                        }
//                    }
//                }
            }
        }

        double elevationScalor = (0.9 - 0.1) / (maxElevation - minElevation);
        System.out.println(minElevation + " " + maxElevation + " elevationScalor " + elevationScalor);


        for (int i = 0; i < allFiles.length; i++) {
            if (allFiles[i].isFile() && (allFiles[i].getName().toUpperCase().endsWith(".ASC"))) {
                double[] y = new double[1];
                if (allFiles[i].getName().toLowerCase().contains("hipped")) {
                    fileName2RoofTypeValue.put(allFiles[i], 0.1);
                    y[0] = 0.1;
                }
                if (allFiles[i].getName().toLowerCase().contains("gable")) {
                    fileName2RoofTypeValue.put(allFiles[i], 0.9);
                    y[0] = 0.9;
                }

                trainY.add(y);

                double[] x = new double[64 * 32];

                Grid2DSquareCellDoubleFactory gdf = new Grid2DSquareCellDoubleFactory(new File(folder), -9999.0, new HashSet(), false);
                AbstractGrid2DSquareCell g1 = gdf.create(allFiles[i]);
                long ncol = g1.get_NCols(false);
                long nrow = g1.get_NRows(false);
                // collect all data and the min and max
                for (int m = 0; m < nrow; m++) {
                    for (int n = 0; n < ncol; n++) {
                        x[m * (int) ncol + n] = g1.getCellDouble(m, n, false);
                    }
                }
                // rescale to 0.1 to 0.9, and set nodata to 0;
                for (int m = 0; m < nrow; m++) {
                    for (int n = 0; n < ncol; n++) {
                        if (g1.getCellDouble(m, n, false) == g1.getNoDataValueBigDecimal(false).doubleValue()) {
                            x[m * (int) ncol + n] = 0;
                        } else {
//                            x[m * (int) ncol + n] = g1.getCellDouble(m, n, false) * elevationScalor;
// adding a lot noise
                            if (((int) (Math.random() * 10000000)) % 2 == 0) {
                                x[m * (int) ncol + n] = g1.getCellDouble(m, n, false) * elevationScalor + Math.random() / 10.0d;
                               // System.out.println(g1.getCellDouble(m, n, false) * elevationScalor + " " + x[m * (int) ncol + n]);
                            } else {
                                x[m * (int) ncol + n] = g1.getCellDouble(m, n, false) * elevationScalor - Math.random() / 10.0d;
                               // System.out.println(g1.getCellDouble(m, n, false) * elevationScalor + " " + x[m * (int) ncol + n]);
                            }
                            if (x[m * (int) ncol + n] > 0.9) {
                                x[m * (int) ncol + n] = 0.9;
                            }
                            if (x[m * (int) ncol + n] < 0.1) {
                                x[m * (int) ncol + n] = 0.1;
                            }

                        }
                    }
                }

//                for (int j = 0; j < allFiles.length; j++) {
//                    if (allFiles[j].isDirectory() && (allFiles[j].getName().toLowerCase().contains(allFiles[i].getName().toLowerCase().replaceAll(".asc", "")))) {
//                        g1 = gdf.create(allFiles[i]);
//                        ncol = g1.get_NCols(true);
//                        nrow = g1.get_NRows(true);
//                        for (int m = 0; m < nrow; m++) {
//                            for (int n = 0; n < ncol; n++) {
//                                x[(int) ncol * (int) nrow - 1 + m * (int) ncol + n] = g1.getCellDouble(m, n, true);
//                            }
//                        }
//                    }
//                }

                trainX.add(x);
            }
        }

        trainXArray = trainX.toArray(new double[][]{});
        trainYArray = trainY.toArray(new double[][]{});

        return new double[][][]{trainXArray,
                    trainYArray};
    }

    public static void main(String[] args) {
        readTrainingInputOutput();
    }
}
